
// ClipMM.cpp : AvP[ṼNX`܂B
//

#include "stdafx.h"
#include "afxwinappex.h"
#include "afxdialogex.h"
#include "ClipMM.h"
#include "MainFrm.h"

#include "ClipMMDoc.h"
#include "LeftView.h"
#include "Util.h"
#include "SettingDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

using namespace Gdiplus;

GdiplusStartupInput gdiplusStartupInput;
ULONG_PTR gdiplusToken;

const WCHAR* g_pszVersion = L"1.0.0.2";

UINT g_cfFileContents;
UINT g_cfFileDescriptorA;
UINT g_cfFileDescriptorW;


// CClipMMApp

BEGIN_MESSAGE_MAP(CClipMMApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, &CClipMMApp::OnAppAbout)
	// W̃t@C{hLg R}h
	ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
	ON_COMMAND(ID_TOOL_DELETE_SETTINGS_AND_EXIT, &CClipMMApp::OnToolDeleteSettingsAndExit)
	ON_COMMAND(ID_TOOL_SETTING, &CClipMMApp::OnToolSetting)
END_MESSAGE_MAP()

const WCHAR* g_pszGUID = L"{F60B5956-6986-4CEF-9737-34DAA74A5C1E}";

// CClipMMApp RXgNV

CClipMMApp::CClipMMApp()
	: m_bGdiplusStartup(FALSE)
	, m_hInstanceCheckFile(INVALID_HANDLE_VALUE)
	, m_bUnregister(FALSE)
{
	m_dwRestartManagerSupportFlags = 0;//AFX_RESTART_MANAGER_SUPPORT_ALL_ASPECTS;
#ifdef _MANAGED
	// AvP[Vʌꃉ^C T|[g (/clr) gpč쐬Ăꍇ:
	//     1) ̒ǉݒ́AċN}l[W[ T|[gɋ@\邽߂ɕKvłB
	//     2) 쐬ɂ́AvWFNg System.Windows.Forms ւ̎QƂǉKv܂B
	System::Windows::Forms::Application::SetUnhandledExceptionMode(System::Windows::Forms::UnhandledExceptionMode::ThrowException);
#endif

	// TODO: ̃AvP[V ID ӂ ID Œu܂B
	// ̌` CompanyName.ProductName.SubProduct.VersionInformation ł
	SetAppID(_T("ClipMM.AppID.NoVersion"));
}

CClipMMApp::~CClipMMApp()
{
	if (m_bGdiplusStartup)
		GdiplusShutdown(gdiplusToken);
}

// B CClipMMApp IuWFNgłB

CClipMMApp theApp;


// CClipMMApp 

BOOL CClipMMApp::InitInstance()
{
	// AvP[V }jtFXg visual X^CLɂ邽߂ɁA
	// ComCtl32.dll Version 6 ȍ~̎gpw肷ꍇ́A
	// Windows XP  InitCommonControlsEx() KvłBȂ΁AEBhE쐬ׂ͂Ďs܂B
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// AvP[VŎgp邷ׂẴR Rg[ NX܂߂ɂ́A
	// ݒ肵܂B
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
	m_bGdiplusStartup = TRUE;

	CWinApp::InitInstance();

	g_cfFileContents = RegisterClipboardFormat(CFSTR_FILECONTENTS);
	g_cfFileDescriptorA = RegisterClipboardFormat(CFSTR_FILEDESCRIPTORA);
	g_cfFileDescriptorW = RegisterClipboardFormat(CFSTR_FILEDESCRIPTORW);


	// OLE Cu܂B
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}

	if (!SUCCEEDED(CoCreateInstance(CLSID_WICImagingFactory, nullptr, CLSCTX_INPROC_SERVER, IID_PPV_ARGS(&m_pWICFactory)))) {
		m_pWICFactory = nullptr;
	}

	AfxEnableControlContainer();

	EnableTaskbarInteraction(FALSE);

	// RichEdit Rg[gpɂ AfxInitRichEdit2() Kvł	
	// AfxInitRichEdit2();

	// W
	// ̋@\g킸ɍŏIIȎs\t@C
	// TCYkꍇ́Aȉsvȏ
	// [`폜ĂB
	// ݒ肪i[Ă郌WXg L[ύX܂B
	// TODO: Ж܂͑gDȂǂ̓K؂ȕ
	// ̕ύXĂB
	SetRegistryKey(L"Nbv");
	LoadStdProfileSettings(4);  // W INI t@C̃IvV[h܂ (MRU ܂)

	m_nSubDirSizeLimit = GetProfileInt(L"Settings", L"SubDirSizeLimit", 128);
	m_nHowToGetShellIDList = GetProfileInt(L"Settings", L"HowToGetShellIDList", getshellidlistIShellFolder);

	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CClipMMDoc),
		RUNTIME_CLASS(CMainFrame),       // C SDI t[ EBhE
		RUNTIME_CLASS(CLeftView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);


	// DDEAfile open ȂǕW̃VF R}h̃R}h C͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// e|tH_
	{
		auto PrepareTemporaryFolder = [&](const CString& strParentDir) -> bool 
		{
			m_strTempDir = MakePathName(strParentDir, g_pszGUID);

			// CX^X`FbNp̃t@C
			HANDLE hMutex = CreateMutex(NULL, FALSE, g_pszGUID);
			if (hMutex)
			{
				if (WaitForSingleObject(hMutex, 3000) == WAIT_OBJECT_0)
				{
					CreateDirectory(m_strTempDir, NULL);
					m_strInstanceCheckFileName = MakePathName(m_strTempDir, L"$ichk$.tmp");
					m_hInstanceCheckFile =
						CreateFile(m_strInstanceCheckFileName,
							GENERIC_READ | GENERIC_WRITE,
							FILE_SHARE_READ | FILE_SHARE_WRITE,
							NULL,
							OPEN_ALWAYS,
							FILE_ATTRIBUTE_NORMAL,
							NULL);
					ReleaseMutex(hMutex);
				}
				CloseHandle(hMutex);

				if (m_hInstanceCheckFile == INVALID_HANDLE_VALUE)
				{
					return false;
				}
				return true;
			}
			return false;
		};

		bool bDone = false;
		CString strCustomTempPath = GetProfileString(L"Settings", L"TemporaryFolder", L"");
		if (!strCustomTempPath.IsEmpty()) 
		{
			if (PrepareTemporaryFolder(strCustomTempPath)) 
			{
				bDone = true;
			}
			else 
			{
				AfxMessageBox(L"w肳ꂽꏊɈꎞt@C܂B\r\n"
					L"Windows̃e|tH_gp܂B");
			}
		}
		if (!bDone) 
		{
			CString strTempPath;
			if (GetTempPath(strTempPath)) 
			{
				if (PrepareTemporaryFolder(strTempPath)) 
				{
					bDone = true;
				}
			}
		}
		if (!bDone) 
		{
			AfxMessageBox(L"ꎞt@C܂B");
			return FALSE;
		}
	}

	// R}h CŎw肳ꂽfBXpb` R}hłBAvP[V
	// /RegServerA/RegisterA/Unregserver ܂ /Unregister ŋNꂽꍇAFalse Ԃ܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;


	// C EBhEꂽ̂ŁA\ƍXVs܂B
	((CMainFrame*)m_pMainWnd)->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	// ڔ݂ꍇɂ̂ DragAcceptFiles ĂяoĂB
	//  SDI AvP[Vł́AProcessShellCommand ̒ɂ̌ĂяoȂ΂Ȃ܂B
	return TRUE;
}

int CClipMMApp::ExitInstance()
{
	//TODO: ǉ\[Xꍇɂ͂Ă

	m_pWICFactory = nullptr;			// OleTermOɏ

	AfxOleTerm(FALSE);

	// e|tH_ɃS~cĂ폜
	if (m_hInstanceCheckFile != INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_hInstanceCheckFile);
		// sႢɎ̃CX^XNĂ܂Ȃ悤ɁB
		// ƂȂƂȂłB܂`X͂邾낤B
		HANDLE hMutex = CreateMutex(NULL, FALSE, g_pszGUID);
		if (hMutex)
		{
			if (WaitForSingleObject(hMutex, 1000) == WAIT_OBJECT_0)
			{
				if (DeleteFile(m_strInstanceCheckFileName))
				{
					// Ō̃CX^X炵
					CString strPathNameToSearch = MakePathName(m_strTempDir, L"*.cvtmp");
					WIN32_FIND_DATA wfd;
					HANDLE hFind = FindFirstFile(strPathNameToSearch, &wfd);
					if (hFind != INVALID_HANDLE_VALUE)
					{
						do 
						{
							if (!(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
							{
								CString strPathName = MakePathName(m_strTempDir, wfd.cFileName);
								DeleteFile(strPathName);
							}
						} while (FindNextFile(hFind, &wfd));
						FindClose(hFind);
					}
					RemoveDirectory(m_strTempDir);
				}
				ReleaseMutex(hMutex);
			}
			CloseHandle(hMutex);
		}
	}



	int n =  CWinApp::ExitInstance();

	if (m_bUnregister)
	{
		Unregister();
	}

	return n;
}

CString CClipMMApp::MakeTempPathName()
{
	CTime timeNow = CTime::GetCurrentTime();
	CString strBase;
	strBase.Format(L"%04d%02d%02d%02d%02d%02d", 
		timeNow.GetYear(),
		timeNow.GetMonth(),
		timeNow.GetDay(),
		timeNow.GetHour(),
		timeNow.GetMinute(),
		timeNow.GetSecond());

	for (int i = 0; i < 1000; i++)
	{
		CreateDirectory(m_strTempDir, NULL);	// Ⴂɍ폜Ă獢̂ŔÔ

		unsigned int nR;
		rand_s(&nR);

		CString str1;
		str1.Format(L"%08lx", nR);
		CString str = strBase + str1;

		CString strPathName = MakePathName(m_strTempDir, str + L".cvtmp");

		HANDLE hFile = 
		CreateFile(strPathName, GENERIC_WRITE, 
			0, NULL, CREATE_ALWAYS, 
			FILE_ATTRIBUTE_NORMAL, NULL);

		if (hFile == INVALID_HANDLE_VALUE)
		{
			continue;
		}
		CloseHandle(hFile);
		return strPathName;
	}
	// 
	return L"";
}

// CClipMMApp bZ[W nh[


// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
public:
	CStatic m_staticVersion;
	virtual BOOL OnInitDialog();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_VERSION, m_staticVersion);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CString str = CString(L"Version ") + g_pszVersion + L" (" 
		+ UnsignedDecimalString(sizeof(void*) * 8) + L"bit)";
	m_staticVersion.SetWindowText(str);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

// _CAOs邽߂̃AvP[V R}h
void CClipMMApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// CClipMMApp bZ[W nh[



BOOL CClipMMApp::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_MOUSEWHEEL) 
	{
		if (m_pMainWnd) 
		{
			// J[\ʒu擾
			CPoint ptCursor;
			ptCursor = pMsg->pt;
			// J[\ʒũEBhE߂
			CWnd* pWndAtCursor = m_pMainWnd->WindowFromPoint(ptCursor);
			if (pWndAtCursor) 
			{
				// փbZ[W𓊂
				pWndAtCursor->SendMessage(pMsg->message, pMsg->wParam, pMsg->lParam);
				return TRUE;
			}
		}
	}

	return CWinApp::PreTranslateMessage(pMsg);
}


void CClipMMApp::OnToolDeleteSettingsAndExit()
{
	if (AfxMessageBox(	L"Nbv̐ݒWXg폜ďI܂B\r\n\r\n"
						L"ACXg[ꍇClipMM.exet@Cʓr폜ĂB",
						MB_OKCANCEL) != IDOK) 
	{
		return;
	}
	m_bUnregister = TRUE;
	m_pMainWnd->PostMessage(WM_CLOSE, 0, 0);
}


void CClipMMApp::OnToolSetting()
{
	CSettingDialog dlg;
	dlg.m_nSubDirSizeLimit = m_nSubDirSizeLimit;
	dlg.m_nHowToGetShellIDList = m_nHowToGetShellIDList;
	dlg.m_strTemporaryFolder = GetProfileString(L"Settings", L"TemporaryFolder", L"");

	if (dlg.DoModal() == IDOK)
	{
		m_nSubDirSizeLimit = dlg.m_nSubDirSizeLimit;
		m_nHowToGetShellIDList = dlg.m_nHowToGetShellIDList;
		WriteProfileInt(L"Settings", L"SubDirSizeLimit", m_nSubDirSizeLimit);
		WriteProfileInt(L"Settings", L"HowToGetShellIDList", m_nHowToGetShellIDList);
		WriteProfileString(L"Settings", L"TemporaryFolder", dlg.m_strTemporaryFolder);
	}

}
