
// ClipMMView.cpp : CClipMMView NX̎
//

#include "stdafx.h"
#include "ClipMM.h"

#include "ClipMMDoc.h"
#include "ClipMMView.h"
#include "HexViewDialog.h"
#include "TextViewDialog.h"
#include "ImageViewDialog.h"
#include "Util.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CClipMMView

IMPLEMENT_DYNCREATE(CClipMMView, CView)

BEGIN_MESSAGE_MAP(CClipMMView, CView)
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
//	ON_COMMAND(ID_TOOL_SET_DEFAULT_VIEW, &CClipMMView::OnToolSetDefaultView)
END_MESSAGE_MAP()

// CClipMMView RXgNV/fXgNV

CClipMMView::CClipMMView()
	: m_bPositionInfoInitialized(FALSE)
{
	// TODO: \zR[hɒǉ܂B

}

CClipMMView::~CClipMMView()
{
}

BOOL CClipMMView::PreCreateWindow(CREATESTRUCT& cs)
{
	m_strClassName = AfxRegisterWndClass(CS_DBLCLKS);
	cs.lpszClass = m_strClassName;

	return CView::PreCreateWindow(cs);
}

void CClipMMView::OnInitialUpdate()
{
	CView::OnInitialUpdate();

	if (!m_sheet.m_hWnd)
	{
		m_sheet.AddPage(&m_pageProperty);
		m_sheet.Create(this, WS_CHILD, 0);
		m_sheet.SetOwner(this);

		CTabCtrl* pTab = m_sheet.GetTabControl();

		pTab->ModifyStyle(TCS_FOCUSONBUTTONDOWN, TCS_FOCUSNEVER);

		CRect rcSheetClient;
		m_sheet.GetClientRect(rcSheetClient);
		CRect rcTab;
		pTab->GetWindowRect(rcTab);
		m_sheet.ScreenToClient(rcTab);

		m_cxLeftEdge = rcTab.left - rcSheetClient.left;
		m_cyTopEdge = rcTab.top - rcSheetClient.top;
		m_cxRightEdge = rcSheetClient.right - rcTab.right;
		m_cyBottomEdge = rcSheetClient.bottom - rcTab.bottom;
		m_bPositionInfoInitialized = TRUE;

		SetSheetSize();
	}
}

void CClipMMView::AddAdditionalPropertyPage(shared_ptr<CPropertyPage>& pPage)
{
	m_sheet.AddPage(pPage.get());
	m_pagesAdditional.push_back(pPage);
}

void CClipMMView::RemoveAdditionalPropertyPages()
{
	while (m_sheet.GetPageCount() > 1)
	{
		m_sheet.RemovePage(1);
	}
	m_pagesAdditional.clear();
}


// CClipMMView ff

#ifdef _DEBUG
void CClipMMView::AssertValid() const
{
	CView::AssertValid();
}

void CClipMMView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CClipMMDoc* CClipMMView::GetDocument() const // fobOȊÕo[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CClipMMDoc)));
	return (CClipMMDoc*)m_pDocument;
}
#endif //_DEBUG


void CClipMMView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	if ((lHint & CClipMMDoc::updatehintReset) ||
		(lHint & CClipMMDoc::updatehintSel))
	{
		// Sy[W폜vpeB
		RemoveAdditionalPropertyPages();
	}

	if (lHint & CClipMMDoc::updatehintReset)
	{
		m_pageProperty.SetData(NULL);
	}
	if (lHint & CClipMMDoc::updatehintSel)
	{
		if (pHint)
		{
			CPropertyPage* pPageActive = NULL;

			ASSERT(pHint->IsKindOf(RUNTIME_CLASS(CCBData)));
			CCBData* pData = (CCBData*)pHint;
			int suitabletype = pData->GetSuitableType();
			

			// HEXy[Wǉ
			{
				if (!pData->m_strMemDataFileName.IsEmpty())
				{
					shared_ptr<CPropertyPage> pPage = make_shared<CHexViewDialog>(pData);
					AddAdditionalPropertyPage(pPage);
					if (suitabletype == pData->suitabletypeHex)
					{
						pPageActive = pPage.get();
					}
				}
			}


			// eLXgy[Wǉ
			{
				if (!pData->m_strMemDataFileName.IsEmpty())
				{
					shared_ptr<CPropertyPage> pPage = make_shared<CTextViewDialog>(pData);
					AddAdditionalPropertyPage(pPage);
					if (suitabletype == pData->suitabletypeText)
					{
						pPageActive = pPage.get();
					}
				}

			}

			// C[Wy[Wǉ
			{
				shared_ptr<CPropertyPage> pPage = make_shared<CImageViewDialog>(pData);
				AddAdditionalPropertyPage(pPage);
				if (suitabletype == pData->suitabletypeImage)
				{
					pPageActive = pPage.get();
				}

			}
			m_pageProperty.SetData(pData);

			if (pPageActive)
			{
				m_sheet.SetActivePage(pPageActive);
			}
		}
		else
		{
			m_pageProperty.SetFormatNameArray(GetDocument()->m_arrayFormatNames);
		}
	}
}


void CClipMMView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	SetSheetSize();


}


void CClipMMView::SetSheetSize()
{

	if (m_sheet.m_hWnd && m_bPositionInfoInitialized)
	{
		CRect rcClient;
		GetClientRect(rcClient);

		CTabCtrl* pTab = m_sheet.GetTabControl();

		CRect rcSheetClient;
		m_sheet.GetClientRect(rcSheetClient);

		m_sheet.MoveWindow(rcClient);
		m_sheet.GetClientRect(rcSheetClient);

		int cxTabNew = rcSheetClient.Width() - (m_cxLeftEdge + m_cxRightEdge);
		int cyTabNew = rcSheetClient.Height() - (m_cyTopEdge + m_cyBottomEdge);


		CRect rcTabNew(	rcSheetClient.left + m_cxLeftEdge, 
						rcSheetClient.top + m_cyTopEdge, 
						rcSheetClient.right - m_cxRightEdge, 
						rcSheetClient.bottom - m_cyBottomEdge);
		pTab->MoveWindow(rcTabNew);

		pTab->AdjustRect(FALSE, rcTabNew);

		for (int i = 0; i < m_sheet.GetPageCount(); i++)
		{
			CPropertyPage* pPage = m_sheet.GetPage(i);
			if (pPage->m_hWnd)
			{
				pPage->MoveWindow(rcTabNew);
			}
		}

		if (!m_sheet.IsWindowVisible())
		{
			m_sheet.ShowWindow(SW_SHOW);
		}
	}
}


void CClipMMView::OnDraw(CDC* /*pDC*/)
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
}



void CClipMMView::OnSetFocus(CWnd* pOldWnd)
{
	CView::OnSetFocus(pOldWnd);

	CPropertyPage* pPage = m_sheet.GetActivePage();
	if (pPage && pPage->m_hWnd)
		pPage->SetFocus();

}


void CClipMMView::OnToolSetDefaultView()
{
	CPropertyPage* pPage = m_sheet.GetActivePage();
	if (pPage)
	{
		if (pPage->IsKindOf(RUNTIME_CLASS(CClipMMPropertyPage)))
		{
			((CClipMMPropertyPage*)pPage)->OnToolSetDefaultView();
		}
	}
}

void CClipMMView::SavePersistentInfo()
{
	m_pageProperty.SavePersistentInfo();
}
