// HexViewCtrl.cpp : t@C
//

#include "stdafx.h"
#include "ClipMM.h"
#include "HexViewCtrl.h"
#include "GlobalPtr.h"
#include "Util.h"
#include "NFile.h"

#define MGN_A 2	// AhXƃoCg̊Ԃ̋󔒌
#define MGN_B 1	// oCgƃoCg̊Ԃ̋󔒌
#define MGN_C 2	// oCgƃAXL[\̊Ԃ̋󔒌

#define ID_TIMER 100

// CHexViewCtrl

IMPLEMENT_DYNAMIC(CHexViewCtrl, CWnd)

CHexViewCtrl::CHexViewCtrl()
	: m_pfnCallback(NULL)
	, m_dwCallbackData1(0)
	, m_dwCallbackData2(0)
	, m_cbData(0)
	, m_nLineWidth(16)
	, m_nTopLine(0)
	, m_nLeftCol(0)
	, m_nCurLine(0)
	, m_nCurCol(0)
	, m_nSelLine(0)
	, m_nSelCol(0)
	, m_bHaveFocus(FALSE)
	, m_bCaretShown(FALSE)
	, m_bCapture(FALSE)
{
	m_buf.resize(m_nLineWidth);
}

CHexViewCtrl::~CHexViewCtrl()
{
}

BOOL CHexViewCtrl::Create(DWORD dwStyle0, CWnd* pWndParent, UINT nID)
{
	DWORD dwStyle = dwStyle0 | WS_HSCROLL | WS_VSCROLL;

	BOOL b = 
	CWnd::Create(AfxRegisterWndClass(CS_DBLCLKS, AfxGetApp()->LoadStandardCursor(IDC_IBEAM)), 
		L"", 
		dwStyle,
		CRect(0, 0, 0, 0),
		pWndParent,
		nID,
		NULL);

	return b;
}

void CHexViewCtrl::SetData(ULONGLONG cbData, PFNHEXVIEWCTRL_GETDATA_CALLBACK pfn, DWORD_PTR dw1, DWORD_PTR dw2)
{
	m_cbData = cbData;
	m_pfnCallback = pfn;
	m_dwCallbackData1 = dw1;
	m_dwCallbackData2 = dw2;

	m_nTopLine = 0;
	m_nLeftCol = 0;

	if (m_hWnd)
	{
		CalcScrollParam();
		Invalidate();
	}

	SetCurPos(0, 0, FALSE);
}

void CHexViewCtrl::SetLineWidth(int nWidth)
{
	ASSERT(nWidth > 0);
	m_nLineWidth = nWidth;
	m_buf.resize(m_nLineWidth);

	SetCurPos(0, 0, FALSE);
	m_nTopLine = m_nLeftCol = 0;

	if (m_hWnd)
	{
		CalcScrollParam();
		Invalidate();
	}
}

LONGLONG CHexViewCtrl::AddressFromLineCol(LONGLONG nLine, int nCol, BOOL bEnd)
{
	int nOffset;
	if (nCol < m_cchAddress + MGN_A)
	{
		nOffset = 0;
	}
	else
	{
		nCol -= m_cchAddress + MGN_A;
		if (nCol < m_nLineWidth * (2 + MGN_B))
		{
			nOffset = nCol / (2 + MGN_B);
			int nRelCol = nCol % (2 + MGN_B);
			if (bEnd)
			{
				if (nRelCol)
				{
					nOffset++;
				}
			}
			else
			{
				if (nRelCol >= 2)
				{
					nOffset++;
				}
			}
		}
		else
		{
			nOffset = m_nLineWidth;
		}
	}

	ULONGLONG lAddress = nLine * m_nLineWidth + nOffset;
	if (lAddress > m_cbData)
		lAddress = m_cbData;

	return lAddress;
}


void CHexViewCtrl::SetCurPos(LONGLONG nLine, int nCol, BOOL bSelecting)
{
	ASSERT(nLine >= 0 && nLine <= m_cLines);	// ŏIŝЂƂ܂OK
	ASSERT(nCol >= 0 && nCol <= GetLineLength(nLine));

	// Ƃ̑I͈͂Z[uĂ
	LONGLONG nSelStartLineOld = m_nSelStartLine;
	int nSelStartColOld = m_nSelStartCol;
	LONGLONG nSelEndLineOld = m_nSelEndLine;
	int nSelEndColOld = m_nSelEndCol;
	BOOL bHaveSelRangeOld = !(m_nSelStartLine == m_nSelEndLine && m_nSelStartCol == m_nSelEndCol);

	// ʒuXV
	m_nCurLine = nLine;
	m_nCurCol = nCol;
	if (!bSelecting)
	{
		m_nSelLine = nLine;
		m_nSelCol = nCol;
	}

	UpdateSelStartEnd();
	BOOL bHaveSelRange = !(m_nSelStartLine == m_nSelEndLine && m_nSelStartCol == m_nSelEndCol);

	// V̑I͈͂ĕ`悷B
	if (!bHaveSelRangeOld && !bHaveSelRange)
	{
		// VƂɔ]͂ȂBĕ`sv
	}
	else
	{
		LONGLONG nRedrawStart = min(nSelStartLineOld, m_nSelStartLine);
		LONGLONG nRedrawEnd = max(nSelEndLineOld, m_nSelEndLine);

		nRedrawStart = max(nRedrawStart, m_nTopLine - 1);
		nRedrawEnd = min(nRedrawEnd, m_nTopLine + m_nLinesInWindow + 1);
		if (nRedrawEnd >= nRedrawStart)
		{
			int yTop = (int)((nRedrawStart - m_nTopLine) * m_cyLine + m_cyMargin);
			int yBottom = (int)((nRedrawEnd - m_nTopLine + 1) * m_cyLine + m_cyMargin);
			CRect rc;
			GetClientRect(rc);
			rc.top = max(yTop, rc.top);
			rc.bottom = min(yBottom, rc.bottom);
			InvalidateRect(rc);
		}
	}
	ShowCaretAtCurPos();
}

void CHexViewCtrl::ShowCaretAtCurPos()
{
	BOOL b = FALSE;

	if (m_bHaveFocus)
	{
		LONGLONG nRel = m_nCurLine - m_nTopLine;
		if (nRel >= -1 && nRel <= m_nLinesInWindow + 1)
		{
			int y = m_cyMargin + (int)nRel * m_cyLine;
			int x = (m_nCurCol - m_nLeftCol) * m_cxChar + m_cxMargin;
			SetCaretPos(CPoint(x-1, y));
			b = TRUE;
		}
		else
		{
			b = FALSE;
		}
		if (b)
		{
			if (!m_bCaretShown)
			{
				ShowCaret();
				m_bCaretShown = TRUE;
			}
		}
		else
		{
			if (m_bCaretShown)
			{
				HideCaret();
				m_bCaretShown = FALSE;
			}
		}
	}
}

void CHexViewCtrl::ScrollToShowCurPos()
{
	LONGLONG nNewTopLine = m_nTopLine;
	if (m_nCurLine < m_nTopLine)
	{
		nNewTopLine = m_nCurLine;
	}
	else if (m_nCurLine >= m_nTopLine + m_nLinesInWindow)
	{
		nNewTopLine = max(m_nCurLine - m_nLinesInWindow + 1, 0);
	}
	int nNewLeftCol = m_nLeftCol;
	if (m_nCurCol < m_nLeftCol)
	{
		nNewLeftCol = m_nCurCol;
	}
	else if (m_nCurCol >= m_nLeftCol + m_nColsInWindow)
	{
		nNewLeftCol = max(m_nCurCol - m_nColsInWindow + 1, 0);
	}

	if (nNewTopLine == m_nTopLine)
	{
		if (nNewLeftCol == m_nLeftCol)
		{
			// ړȂ
		}
		else
		{
			// ړ̂
			HScroll(nNewLeftCol, TRUE);
		}
	}
	else
	{
		if (nNewLeftCol == m_nLeftCol)
		{
			// ړ̂
			VScroll(nNewTopLine, TRUE);
		}
		else
		{
			// Sʈړ
			m_nTopLine = nNewTopLine;
			m_nLeftCol = nNewLeftCol;
			Invalidate();

			SCROLLINFO si = {0};
			si.cbSize = sizeof(si);
			si.fMask = SIF_POS;
			si.nPos = (int)(m_nTopLine / m_nVScrollFactor);
			SetScrollInfo(SB_VERT, &si);

			si.nPos = m_nLeftCol;
			SetScrollInfo(SB_HORZ, &si);

			ShowCaretAtCurPos();
		}
	}


}

void CHexViewCtrl::VScroll(LONGLONG nNewTopLine, BOOL bSetBar)
{
	LONGLONG nLinesToScroll = nNewTopLine - m_nTopLine;

	m_nTopLine = nNewTopLine;

	if (nLinesToScroll == 0)
	{
	}
	else if (abs(nLinesToScroll) >= m_nLinesInWindow)
	{
		Invalidate();
		ShowCaretAtCurPos();
	}
	else
	{
		ScrollWindow(0, (int)(-nLinesToScroll * m_cyLine));
		ShowCaretAtCurPos();
	}

	if (bSetBar)
	{
		SCROLLINFO si = {0};
		si.cbSize = sizeof(si);
		si.fMask = SIF_POS;
		si.nPos = (int)(m_nTopLine / m_nVScrollFactor);
		SetScrollInfo(SB_VERT, &si);
	}
}

void CHexViewCtrl::HScroll(int nNewLeftCol, BOOL bSetBar)
{
	int nColsToScroll = nNewLeftCol - m_nLeftCol;
	m_nLeftCol = nNewLeftCol;

	if (nColsToScroll == 0)
	{
	}
	else if (abs(nColsToScroll) >= m_nColsInWindow)
	{
		Invalidate();
		ShowCaretAtCurPos();
	}
	else
	{
		ScrollWindow((int)(-nColsToScroll * m_cxChar), 0);
		ShowCaretAtCurPos();
	}

	if (bSetBar)
	{
		SCROLLINFO si = {0};
		si.cbSize = sizeof(si);
		si.fMask = SIF_POS;
		si.nPos = m_nLeftCol;
		SetScrollInfo(SB_HORZ, &si);
	}
}

int CHexViewCtrl::GetLineWidthOfThisLine(LONGLONG nLine)
{
	if (nLine < 0 || nLine >= m_cLines)
	{
		return 0;
	}
	int cb = m_nLineWidth;
	if (nLine == m_cLines - 1)
	{
		cb = m_cbData % m_nLineWidth;
		if (cb == 0)
			cb = m_nLineWidth;
	}
	return cb;
}

BEGIN_MESSAGE_MAP(CHexViewCtrl, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_SYSCOLORCHANGE()
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_SETFOCUS()
	ON_WM_KILLFOCUS()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MBUTTONDBLCLK()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_RBUTTONDBLCLK()
	ON_WM_KEYDOWN()
	ON_WM_CHAR()
	ON_WM_GETDLGCODE()
	ON_WM_TIMER()
	ON_WM_MOUSEMOVE()
	ON_WM_CANCELMODE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MOUSEWHEEL()
	ON_COMMAND(ID_EDIT_COPY, &CHexViewCtrl::OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, &CHexViewCtrl::OnUpdateEditCopy)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_SELECT_ALL, &CHexViewCtrl::OnEditSelectAll)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_ALL, &CHexViewCtrl::OnUpdateEditSelectAll)
	ON_COMMAND(ID_EDIT_EXPORT, &CHexViewCtrl::OnEditExport)
	ON_UPDATE_COMMAND_UI(ID_EDIT_EXPORT, &CHexViewCtrl::OnUpdateEditExport)
END_MESSAGE_MAP()



// CHexViewCtrl bZ[W nh[




int CHexViewCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	// gbNX
	m_font.CreatePointFont(90, L"lr SVbN");
	{
		CClientDC dc(this);
		CFont* pFontOld = dc.SelectObject(&m_font);
		TEXTMETRIC tm = {0};
		dc.GetTextMetrics(&tm);
		m_cyChar = tm.tmHeight;
		m_cxChar = tm.tmAveCharWidth;
	}
	m_cyLine = m_cyChar;

	m_cxMargin = (m_cxChar + 1) / 2;
	m_cyMargin = 2;
	m_cxCaret = 1;

	m_nCurLine = m_nSelLine = 0;
	m_nCurCol = m_nSelCol = 0;
	UpdateSelStartEnd();

	GetSysColors();

	CalcScrollParam();

	return 0;
}


void CHexViewCtrl::OnDestroy()
{
	CWnd::OnDestroy();

	// TODO: ɃbZ[W nh[ R[hǉ܂B
}


void CHexViewCtrl::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	int nSaveDCID = dc.SaveDC();

	CRect rcClip;
	dc.GetClipBox(rcClip);

	dc.SelectObject(&m_font);

	// `Jns
	int yRel = rcClip.top - m_cyMargin;
	int nRel;
	if (yRel < 0)
	{
		nRel = -(-yRel / m_cyLine + 1);		// [؂グ	
	}
	else
	{
		nRel = yRel / m_cyLine;				// [؂̂
	}


	for (; ; nRel++)
	{
		LONGLONG nLine = m_nTopLine + nRel;
		int y = nRel * m_cyLine + m_cyMargin;
		if (y > rcClip.bottom)
			break;

		if (nLine < m_cLines)
		{
			DrawLine(&dc, nLine, y);
		}
		else 
		{
			break;
		}
	}

	// cĂȂ
	int y = nRel * m_cyLine + m_cyMargin;
	if (y < rcClip.bottom)
	{
		CRect rc;
		rc.left = rcClip.left;
		rc.right = rcClip.right;
		rc.top = y;
		rc.bottom = rcClip.bottom;
		dc.FillSolidRect(rc, m_crBackground);
	}

	dc.RestoreDC(nSaveDCID);

}

void CHexViewCtrl::DrawLine(CDC* pDC, LONGLONG nLine, int y)
{
	CRect rcClip;
	pDC->GetClipBox(rcClip);

	if (nLine < 0 || nLine >= m_cLines)
	{
		// ̂
		CRect rc;
		rc.left = rcClip.left;
		rc.right = rcClip.right;
		rc.top = y;
		rc.bottom = y + m_cyLine;

		pDC->FillSolidRect(rc, m_crBackground);
	}
	else
	{
		int nSelCol, cSelCols;
		GetSelPositionInLine(nLine, nSelCol, cSelCols);
		CString strLine = GetLineText(nLine);
		int cchLine = strLine.GetLength();
		ASSERT(nSelCol + cSelCols <= cchLine);
		ASSERT(GetLineLength(nLine) == cchLine);
		vector<INT> dx(cchLine + 1);
		for (int i = 0; i < cchLine; i++)
			dx[i] = m_cxChar;

		// [}[W
		int x = -m_nLeftCol * m_cxChar;
		CRect rc;
		rc.left = x;
		rc.right = x + m_cxMargin;
		rc.top = y;
		rc.bottom = y + m_cyLine;
		pDC->FillSolidRect(rc, m_crBackground);
		x = rc.right;

		pDC->SetBkMode(OPAQUE);

		if (cSelCols && m_bHaveFocus)
		{
			// [IĂȂ
			if (nSelCol)
			{
				rc.left = x;
				rc.right = x + nSelCol * m_cxChar;
				pDC->SetBkColor(m_crTextBack);
				pDC->SetTextColor(m_crText);
				pDC->ExtTextOut(x, y, ETO_OPAQUE, rc, strLine.Left(nSelCol), dx.data());
				x = rc.right;
			}

			// IĂ镔
			rc.left = x;
			rc.right = x + cSelCols * m_cxChar;
			pDC->SetBkColor(m_crSelTextBack);
			pDC->SetTextColor(m_crSelText);
			pDC->ExtTextOut(x, y, ETO_OPAQUE, rc, strLine.Mid(nSelCol, cSelCols), dx.data());
			x = rc.right;

			// IĂȂ
			if (nSelCol + cSelCols < cchLine)
			{
				int cch = cchLine - (nSelCol + cSelCols);
				rc.left = x;
				rc.right = x + cch * m_cxChar;
				pDC->SetBkColor(m_crTextBack);
				pDC->SetTextColor(m_crText);
				pDC->ExtTextOut(x, y, ETO_OPAQUE, rc, strLine.Mid(nSelCol + cSelCols), dx.data());
				x = rc.right;
			}
		}
		else
		{
			// Ŝ
			rc.left = x;
			rc.right = x + cchLine * m_cxChar;
			pDC->SetBkColor(m_crTextBack);
			pDC->SetTextColor(m_crText);
			pDC->ExtTextOut(x, y, ETO_OPAQUE, rc, strLine, dx.data());
			x = rc.right;
		}

		// eLXgE
		if (x < rcClip.right)
		{
			rc.left = x;
			rc.right = rcClip.right;
			pDC->FillSolidRect(rc, m_crBackground);
		}
	}
}

void CHexViewCtrl::UpdateSelStartEnd()
{

	BOOL bSelectingForward ;
	if (m_nCurLine > m_nSelLine)
	{
		// ォ牺֑I
		bSelectingForward = TRUE;
	}
	else if (m_nCurLine == m_nSelLine)
	{
		if (m_nCurCol > m_nSelCol)
		{
			// sōEɑI
			bSelectingForward = TRUE;
		}
		else
		{
			// sŉE獶ɑI
			bSelectingForward = FALSE;
		}
	}
	else
	{
		// ɑI
		bSelectingForward = FALSE;
	}

	if (bSelectingForward)
	{
		m_nSelStartLine = m_nSelLine;
		m_nSelStartCol =  m_nSelCol;
		m_nSelEndLine = m_nCurLine;
		m_nSelEndCol = m_nCurCol;
	}
	else
	{
		m_nSelStartLine = m_nCurLine;
		m_nSelStartCol =  m_nCurCol;
		m_nSelEndLine = m_nSelLine;
		m_nSelEndCol = m_nSelCol;
	}

}

void CHexViewCtrl::GetSelPositionInLine(LONGLONG nLine, int& nSelCol, int& cSelCols)
{

	if (nLine < m_nSelStartLine)
	{
		// I𖳊֌W
		nSelCol = 0;
		cSelCols = 0;
	}
	else if (nLine == m_nSelStartLine)
	{
		if (nLine == m_nSelEndLine)
		{
			// sőIĂ
			nSelCol = m_nSelStartCol;
			cSelCols = m_nSelEndCol - m_nSelStartCol;
			ASSERT(cSelCols >= 0);
		}
		else
		{
			// ̍s͑IJn݂̂ł܂őIĂ
			nSelCol = m_nSelStartCol;
			cSelCols = GetLineLength(nLine) - m_nSelStartCol;
		}
	}
	else if (nLine < m_nSelEndLine)
	{
		// ̍s͑SI͈͓ł
		nSelCol = 0;
		cSelCols = GetLineLength(nLine);
	}
	else if (nLine == m_nSelEndLine)
	{
		// ̍s̓r܂łIĂ
		nSelCol = 0;
		cSelCols = m_nSelEndCol;
	}
	else
	{
		// I𖳊֌W
		nSelCol = 0;
		cSelCols = 0;
	}

}

int CHexViewCtrl::GetLineLength(LONGLONG nLine)
{
	int cb = GetLineWidthOfThisLine(nLine);
	if (!cb)
		return 0;

	return m_cchAddress 
		+ MGN_A 
		+ m_nLineWidth * 2 
		+ (m_nLineWidth - 1) * MGN_B
		+ MGN_C 
		+ cb;
}

CString CHexViewCtrl::GetLineText(LONGLONG nLine)
{
	if (nLine < 0 || nLine >= m_cLines)
		return L"";

	CString str;
	int cch = GetLineLength(nLine);
	WCHAR* pchBuf = str.GetBuffer(cch);
	GetLineText(pchBuf, nLine);
	str.ReleaseBuffer(cch);
	return str;

}

static const WCHAR hexchr[] = L"0123456789abcdef";
#define OUTHEX(value) *(pchOut++) = hexchr[((value) >> 4) & 0xF]; *(pchOut++) = hexchr[(value) & 0xF];
#define OUTASCII(value) *(pchOut++) = ((value) >= 0x20 && (value) < 0x7F) ? (WCHAR)(value) : L'.';

void CHexViewCtrl::GetLineText(WCHAR* pchOutBuf, LONGLONG nLine)
{
	ASSERT(nLine >= 0 && nLine < m_cLines);

	int cb = GetLineWidthOfThisLine(nLine);
	ASSERT(cb);

	ULONGLONG ullAddress = nLine * m_nLineWidth;
	(*m_pfnCallback)(ullAddress, cb, m_buf.data(), m_dwCallbackData1, m_dwCallbackData2);


	WCHAR* pchOut = pchOutBuf;
	// AhXo
	for (int i = m_cchAddress - 1; i >= 0; i--)
	{
		*(pchOut++) = hexchr[(ullAddress >> (i * 4)) & 0xF];
	}

	// AhX̂Ƃ̋
	for (int i = 0; i < MGN_A; i++)
		*(pchOut++) = L' ';

	// ŏ̃oCg
	OUTHEX(m_buf[0]);

	// ̃oCgȍ~͋󔒂JȂ
	for (int i = 1; i < cb; i++)
	{
		for (int j = 0; j < MGN_B; j++)
			*(pchOut++) = L' ';
		OUTHEX(m_buf[i]);
	}

	// oCg񂪒ZŏIs͋󔒂𖄂߂
	for (int i = cb; i < m_nLineWidth; i++)
	{
		for (int j = 0; j < MGN_B + 2; j++)
			*(pchOut++) = L' ';
	}

	// AXL[_v̑Ő
	for (int i = 0; i < MGN_C; i++)
		*(pchOut++) = L' ';

	// AXL[_v
	for (int i = 0; i < cb; i++)
		OUTASCII(m_buf[i]);
}

void CHexViewCtrl::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	CalcScrollParam();
	Invalidate();
}


void CHexViewCtrl::OnSysColorChange()
{
	CWnd::OnSysColorChange();

	GetSysColors();
}

void CHexViewCtrl::GetSysColors()
{
	m_crBackground = GetSysColor(COLOR_WINDOW);
	m_crText = GetSysColor(COLOR_WINDOWTEXT);
	m_crTextBack = GetSysColor(COLOR_WINDOW);
	m_crSelText = GetSysColor(COLOR_HIGHLIGHTTEXT);
	m_crSelTextBack = GetSysColor(COLOR_HIGHLIGHT);
}

void CHexViewCtrl::CalcScrollParam()
{
	if (!m_hWnd)
		return;

	CRect rcClient;
	GetClientRect(rcClient);

	// XN[
	{
		m_cLines = (m_cbData + m_nLineWidth - 1) / m_nLineWidth;
		m_nLinesInWindow = (rcClient.Height() - m_cyMargin * 2) / m_cyChar;
		if ((m_cLines + 1) > m_nLinesInWindow)
			m_nVScrollMax = m_cLines - m_nLinesInWindow + 1;
		else
			m_nVScrollMax = 0;
		if (m_nTopLine > m_nVScrollMax)
		{
			m_nTopLine = m_nVScrollMax;
		}

		// INT_MAX𒴂Ăn1ɂ
		m_nVScrollFactor = 1;
		if (m_nVScrollMax >= INT_MAX)
		{
			m_nVScrollFactor = (int)(m_nVScrollMax / INT_MAX + 1);
		}

		SCROLLINFO si = {0};
		si.cbSize = sizeof(si);
		si.fMask = SIF_PAGE | SIF_POS | SIF_RANGE;
		si.nMin = 0;
		si.nMax = (int)(m_cLines / m_nVScrollFactor);
		si.nPos = (int)(m_nTopLine / m_nVScrollFactor);
		si.nPage = (int)(m_nLinesInWindow / m_nVScrollFactor);
		SetScrollInfo(SB_VERT, &si);
	}

	// XN[
	{
		if (m_cbData <= WORD_MAX)
		{
			m_cchAddress = 4;
		}
		else if (m_cbData <= ULONG_MAX)
		{
			m_cchAddress = 8;
		}
		else
		{
			m_cchAddress = 16;
		}
		
		m_cchLine = GetLineLength(0);
		m_nColsInWindow = (rcClient.Width() - m_cxMargin * 2) / m_cxChar;
		if (m_cchLine > m_nColsInWindow)
			m_nHScrollMax = m_cchLine - m_nColsInWindow;
		else
			m_nHScrollMax = 0;
		if (m_nLeftCol > m_nHScrollMax)
			m_nLeftCol = m_nHScrollMax;

		SCROLLINFO si = {0};
		si.cbSize = sizeof(si);
		si.fMask = SIF_PAGE | SIF_POS | SIF_RANGE;
		si.nMin = 0;
		si.nMax = m_cchLine - 1;
		si.nPos = m_nLeftCol;
		si.nPage = m_nColsInWindow;
		SetScrollInfo(SB_HORZ, &si);
	}
}



void CHexViewCtrl::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	LONGLONG nNew = m_nTopLine;
	BOOL bSetPos = TRUE;
	BOOL bForceSetPos = FALSE;

	switch (nSBCode)
	{
	case SB_BOTTOM:		// Scrolls to the lower right.
		nNew = m_nVScrollMax;
		break;
	case SB_ENDSCROLL:	// Ends scroll.
		break;
	case SB_LINEDOWN:	// Scrolls one line down.
		nNew = min(nNew + 1, m_nVScrollMax);
		break;
	case SB_LINEUP:		// Scrolls one line up.
		nNew = max(nNew - 1, 0);
		break;
	case SB_PAGEDOWN:	// Scrolls one page down.
		nNew = min(nNew + m_nLinesInWindow, m_nVScrollMax);
		break;
	case SB_PAGEUP:		// Scrolls one page up.
		nNew = max(nNew - m_nLinesInWindow, m_nHScrollMax);
		break;
	case SB_THUMBPOSITION:	// The user has dragged the scroll box (thumb) and released the mouse button. The HIWORD indicates the position of the scroll box at the end of the drag operation.
	case SB_THUMBTRACK:	// The user is dragging the scroll box. This message is sent repeatedly until the user releases the mouse button. The HIWORD indicates the position that the scroll box has been dragged to.
		{
			SCROLLINFO si = {0};
			si.cbSize = sizeof(si);
			si.fMask = SIF_TRACKPOS;
			GetScrollInfo(SB_VERT, &si);
			nNew = (LONGLONG)si.nTrackPos * m_nVScrollFactor;
			if (nSBCode == SB_THUMBTRACK)
				bSetPos = FALSE;
			else
				bForceSetPos = TRUE;
		}
		break;
	case SB_TOP:
		nNew = 0;
		break;
	}

	if (nNew != m_nTopLine || bForceSetPos)
	{
		VScroll(nNew, bSetPos);
		UpdateWindow();
	}
	CWnd::OnVScroll(nSBCode, nPos, pScrollBar);
}


void CHexViewCtrl::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	int nNew = m_nLeftCol;
	BOOL bSetPos = TRUE;
	BOOL bForceSetPos = FALSE;
	static const int nPageSize = 8;

	switch (nSBCode)
	{
	case SB_ENDSCROLL:		// Ends scroll.
		break;
	case SB_LEFT:			// Scrolls to the upper left.
		nNew = 0;
		break;
	case SB_RIGHT:			// Scrolls to the lower right.
		nNew = m_nHScrollMax;
		break;
	case SB_LINELEFT:		// Scrolls left by one unit.
		nNew = max(nNew - 1, 0);
		break;
	case SB_LINERIGHT:		// Scrolls right by one unit.
		nNew = min(nNew + 1, m_nHScrollMax);
		break;
	case SB_PAGELEFT:		// Scrolls left by the width of the window.
		nNew = max(nNew - nPageSize, 0);
		break;
	case SB_PAGERIGHT:		// Scrolls right by the width of the window.
		nNew = min(nNew + nPageSize, m_nHScrollMax);
		break;
	case SB_THUMBPOSITION:	// The user has dragged the scroll box (thumb) and released the mouse button. The HIWORD indicates the position of the scroll box at the end of the drag operation.
	case SB_THUMBTRACK:		// The user is dragging the scroll box. This message is sent repeatedly until the user releases the mouse button. The HIWORD indicates the position that the scroll box has been dragged to.
		{
			SCROLLINFO si = {0};
			si.cbSize = sizeof(si);
			si.fMask = SIF_TRACKPOS;
			GetScrollInfo(SB_HORZ, &si);
			nNew = si.nTrackPos;
			if (nSBCode == SB_THUMBTRACK)
				bSetPos = FALSE;
			else
				bForceSetPos = TRUE;
		}
	}

	if (nNew != m_nLeftCol || bForceSetPos)
	{
		HScroll(nNew, bSetPos);
		UpdateWindow();
	}

	CWnd::OnHScroll(nSBCode, nPos, pScrollBar);
}


void CHexViewCtrl::OnSetFocus(CWnd* pOldWnd)
{
	CreateSolidCaret(m_cxCaret, m_cyChar);

	m_bHaveFocus = TRUE;
	Invalidate();
	ShowCaretAtCurPos();

	CWnd::OnSetFocus(pOldWnd);

}


void CHexViewCtrl::OnKillFocus(CWnd* pNewWnd)
{
	CWnd::OnKillFocus(pNewWnd);

	m_bHaveFocus = FALSE;
	Invalidate();
	if (m_bCaretShown)
	{
		HideCaret();
		m_bCaretShown = FALSE;
	}

	DestroyCaret();
}


void CHexViewCtrl::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	BOOL bShift = GetKeyState(VK_SHIFT) < 0;

	LONGLONG nLine;
	int nCol;
	if (HitTest(point, nLine, nCol, TRUE))
	{
		SetCurPos(nLine, nCol, bShift);
		ScrollToShowCurPos();
		UpdateWindow();

		SetCapture();
		SetTimer(ID_TIMER, 100, NULL);
		m_ptLastMousePos = point;
		m_bCapture = TRUE;
	}

	CWnd::OnLButtonDown(nFlags, point);
}


void CHexViewCtrl::OnLButtonUp(UINT nFlags, CPoint point)
{
	if (m_bCapture)
	{
		m_bCapture = FALSE;
		ReleaseCapture();
		KillTimer(ID_TIMER);
	}

	CWnd::OnLButtonUp(nFlags, point);
}

void CHexViewCtrl::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	LONGLONG nLine;
	int nCol;
	if (HitTest(point, nLine, nCol, FALSE))
	{
		SelectWord(nLine, nCol);
		ScrollToShowCurPos();
		UpdateWindow();
	}

	CWnd::OnLButtonDblClk(nFlags, point);
}

void CHexViewCtrl::OnRButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();

	CWnd::OnRButtonDown(nFlags, point);
}


void CHexViewCtrl::OnRButtonUp(UINT nFlags, CPoint point)
{
	CWnd::OnRButtonUp(nFlags, point);
}


void CHexViewCtrl::OnRButtonDblClk(UINT nFlags, CPoint point)
{
	CWnd::OnRButtonDblClk(nFlags, point);
}

void CHexViewCtrl::OnMouseMove(UINT nFlags, CPoint point)
{
	if (m_bCapture)
	{
		SelMouse(point);
		m_ptLastMousePos = point;
	}

	CWnd::OnMouseMove(nFlags, point);
}

void CHexViewCtrl::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == ID_TIMER && m_bCapture)
	{
		// }EXړCxgN
		SelMouse(m_ptLastMousePos);
	}

	CWnd::OnTimer(nIDEvent);
}

BOOL CHexViewCtrl::HitTest(CPoint point, LONGLONG& nLine, int& nCol, BOOL bBetween)
{
	int x1 = point.x - m_cxMargin;
	if (bBetween)
		x1 += m_cxChar / 2;
	nCol = x1 / m_cxChar + m_nLeftCol;

	nLine = (point.y - m_cyMargin) / m_cyChar + m_nTopLine;

	if (nLine < 0)
		nLine = 0;
	else if (nLine > m_cLines)
		nLine = m_cLines;

	int cchLine = GetLineLength(nLine);
	if (nCol < 0)
		nCol = 0;
	if (nCol > cchLine)
		nCol = cchLine;

	return TRUE;
}

void CHexViewCtrl::SelMouse(CPoint point)
{
	LONGLONG nLine;
	int nCol;
	if (HitTest(point, nLine, nCol, TRUE))
	{
		SetCurPos(nLine, nCol, TRUE);
		ScrollToShowCurPos();
		UpdateWindow();

	}
}

void CHexViewCtrl::SelectWord(LONGLONG nLine, int nCol)
{
	ASSERT(nLine >= 0 && nLine <= m_cLines);
	ASSERT(nCol >= 0 && nCol <= GetLineLength(nLine));

	CString strLine = GetLineText(nLine);
	const WCHAR* pszLine = (const WCHAR*)strLine;
	int cchLine = GetLineLength(nLine);
	
	SetCurPos(nLine, nCol, FALSE);

	// ÕXy[X܂
	if (m_nCurCol)
	{
		CursorPrevWord(FALSE);
	}

	// ̃Xy[X܂
	if (m_nCurCol < cchLine)
	{
		CursorNextWord(TRUE);
	}
}

void CHexViewCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	BOOL bCtrl = (GetKeyState(VK_CONTROL) < 0);
	BOOL bShift = (GetKeyState(VK_SHIFT) < 0);

	switch (nChar)
	{
	case VK_LEFT:
		if (bCtrl)
			CursorPrevWord(bShift);// O̒P
		else
			CursorLeft(bShift);
		break;
	case VK_RIGHT:
		if (bCtrl)
			CursorNextWord(bShift);// ̒P
		else
			CursorRight(bShift);
		break;
	case VK_UP:
		if (bCtrl)
			;
		else
			CursorUp(bShift);
		break;
	case VK_DOWN:
		if (bCtrl)
			;
		else
			CursorDown(bShift);
		break;
	case VK_PRIOR:
		CursorPageUp(bShift);
		break;
	case VK_NEXT:
		CursorPageDown(bShift);
		break;
	case VK_HOME:
		if (bCtrl)
			CursorBOF(bShift);
		else
			CursorBOL(bShift);
		break;
	case VK_END:
		if (bCtrl)
			CursorEOF(bShift);
		else
			CursorEOL(bShift);
		break;
	}

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}


void CHexViewCtrl::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// TODO: ɃbZ[W nh[ R[hǉ邩ȀĂяo܂B

	CWnd::OnChar(nChar, nRepCnt, nFlags);
}

void CHexViewCtrl::CursorLeft(BOOL bSelecting)
{
	int nNewCol = m_nCurCol;
	LONGLONG nNewLine = m_nCurLine;

	if (nNewCol > 0)
		nNewCol--;
	else
	{
		if (nNewLine > 0)
		{
			nNewLine--;
			nNewCol = GetLineLength(nNewLine);
		}
		else
		{
			return;
		}
	}

	SetCurPos(nNewLine, nNewCol, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

void CHexViewCtrl::CursorRight(BOOL bSelecting)
{
	int nNewCol = m_nCurCol;
	LONGLONG nNewLine = m_nCurLine;
	int nLineLength = GetLineLength(m_nCurLine);

	if (nNewCol < nLineLength)
		nNewCol++;
	else
	{
		if (nNewLine < m_cLines)
		{
			nNewLine++;
			nNewCol = 0;
		}
		else
		{
			return;
		}
	}
	SetCurPos(nNewLine, nNewCol, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

void CHexViewCtrl::CursorUp(BOOL bSelecting)
{
	int nNewCol = m_nCurCol;
	LONGLONG nNewLine = m_nCurLine;

	if (nNewLine > 0)
	{
		nNewLine--;
	}
	else
	{
		return;
	}

	int nLineLength = GetLineLength(nNewLine);
	if (nNewCol > nLineLength)
	{
		nNewCol = nLineLength;
	}

	SetCurPos(nNewLine, nNewCol, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

void CHexViewCtrl::CursorDown(BOOL bSelecting)
{
	int nNewCol = m_nCurCol;
	LONGLONG nNewLine = m_nCurLine;

	if (nNewLine < m_cLines)
	{
		nNewLine++;
	}
	else
	{
		return;
	}

	int nLineLength = GetLineLength(nNewLine);
	if (nNewCol > nLineLength)
	{
		nNewCol = nLineLength;
	}


	SetCurPos(nNewLine, nNewCol, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

#define ISSPACE1(c) ((c) == L' ' || (c) == L'.')

void CHexViewCtrl::CursorPrevWord(BOOL bSelecting)
{
	LONGLONG nNewLine = m_nCurLine;
	int nNewCol = m_nCurCol;

	if (nNewCol == 0)
	{
		// O̍s̍s
		if (nNewLine)
		{
			nNewLine--;
			nNewCol = GetLineLength(nNewLine);
		}
		else
		{
			return;
		}
	}
	else
	{
		nNewCol--;
		CString strLine = GetLineText(nNewLine);
		const WCHAR* pszLine = strLine;
		// 󔒂΃XLbv
		while (nNewCol > 0)
		{
			if (!ISSPACE1(pszLine[nNewCol]))
				break;
			nNewCol--;
		}
		// 󔒂o܂ŃXLbv
		while (nNewCol > 0)
		{
			if (ISSPACE1(pszLine[nNewCol]))
			{
				nNewCol++;
				break;
			}
			nNewCol--;
		}
	}

	SetCurPos(nNewLine, nNewCol, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

void CHexViewCtrl::CursorNextWord(BOOL bSelecting)
{
	LONGLONG nNewLine = m_nCurLine;
	int nNewCol = m_nCurCol;

	int cchLine = GetLineLength(nNewLine);
	if (nNewCol >= cchLine)
	{
		// sȂ玟̍s
		if (nNewLine < m_cLines)
		{
			nNewLine++;
			nNewCol = 0;
		}
		else
		{
			return;
		}
	}
	else
	{
		CString strLine = GetLineText(nNewLine);
		const WCHAR* pszLine = (const WCHAR*)strLine;

		// Xy[XXLbv
		while (nNewCol < cchLine)
		{
			if (ISSPACE1(pszLine[nNewCol]))
			{
				break;
			}
			nNewCol++;
		}
		// Xy[XXLbv
		while (nNewCol < cchLine)
		{
			if (!ISSPACE1(pszLine[nNewCol]))
			{
				break;
			}
			nNewCol++;
		}
	}


	SetCurPos(nNewLine, nNewCol, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

void CHexViewCtrl::CursorPageUp(BOOL bSelecting)
{
	// ݃XN[ʒu1y[WXN[̂DB
	// J[\ʒuȂƂ̓J[\̕𓮂B

	LONGLONG nNewLine = m_nCurLine;
	int nNewCol = m_nCurCol;

	if (m_nTopLine == 0)
		return;

	LONGLONG nLinesToScroll = min(m_nTopLine, m_nLinesInWindow);
	if (nLinesToScroll == 0)
		nLinesToScroll = 1;		// EBhE1sȂĂ1s̓XN[

	LONGLONG nNewTopLine = m_nTopLine - nLinesToScroll;
	nNewLine = max(nNewLine - nLinesToScroll, 0);

	if (nNewLine < nNewTopLine)
		nNewLine = nNewTopLine;
	if (nNewLine >= nNewTopLine + m_nLinesInWindow)
		nNewLine = max(nNewTopLine + m_nLinesInWindow - 1, 0);

	int cchLine = GetLineLength(nNewLine);
	if (nNewCol > cchLine)
		nNewCol = cchLine;


	VScroll(nNewTopLine, TRUE);
	SetCurPos(nNewLine, nNewCol, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();

}

void CHexViewCtrl::CursorPageDown(BOOL bSelecting)
{
	LONGLONG nNewLine = m_nCurLine;
	int nNewCol = m_nCurCol;

	if (m_nTopLine >= m_nVScrollMax)
		return;

	LONGLONG nLinesToScroll = min(m_nVScrollMax - m_nTopLine, m_nLinesInWindow);
	if (nLinesToScroll == 0)
		nLinesToScroll = 1;

	LONGLONG nNewTopLine = m_nTopLine + nLinesToScroll;
	nNewLine = min(nNewLine + nLinesToScroll, m_cLines);

	if (nNewLine < nNewTopLine)
		nNewLine = nNewTopLine;
	if (nNewLine >= nNewTopLine + m_nLinesInWindow)
		nNewLine = max(nNewTopLine + m_nLinesInWindow - 1, 0);

	int cchLine = GetLineLength(nNewLine);
	if (nNewCol > cchLine)
		nNewCol = cchLine;

	VScroll(nNewTopLine, TRUE);
	SetCurPos(nNewLine, nNewCol, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();

}

void CHexViewCtrl::CursorBOL(BOOL bSelecting)
{
	if (m_nCurCol == 0)
		return;
	SetCurPos(m_nCurLine, 0, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

void CHexViewCtrl::CursorEOL(BOOL bSelecting)
{
	int cchLine = GetLineLength(m_nCurLine);
	if (m_nCurCol == cchLine)
		return;
	SetCurPos(m_nCurLine, cchLine, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

void CHexViewCtrl::CursorBOF(BOOL bSelecting)
{
	if (m_nCurLine == 0 && m_nCurCol == 0)
		return;
	SetCurPos(0, 0, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

void CHexViewCtrl::CursorEOF(BOOL bSelecting)
{
	if (m_nCurLine == m_cLines && m_nCurCol == 0)
		return;
	SetCurPos(m_cLines, 0, bSelecting);
	ScrollToShowCurPos();
	UpdateWindow();
}

UINT CHexViewCtrl::OnGetDlgCode()
{
	return DLGC_WANTARROWS;
//	return CWnd::OnGetDlgCode();
}



void CHexViewCtrl::OnCancelMode()
{
	CWnd::OnCancelMode();

	if (m_bCapture)
	{
		m_bCapture = FALSE;
		ReleaseCapture();
		KillTimer(ID_TIMER);
	}
}


BOOL CHexViewCtrl::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	int nLinesToScroll = -zDelta / (120 / 3);
	LONGLONG nNewTopLine = min(max(m_nTopLine + nLinesToScroll, 0), m_cLines);
	if (nNewTopLine != m_nTopLine)
	{
		VScroll(nNewTopLine, TRUE);
	}

	return CWnd::OnMouseWheel(nFlags, zDelta, pt);
}

#define OUT_CRLF() {*pchDst++ = L'\r'; *pchDst++ = L'\n';}

void CHexViewCtrl::OnEditCopy()
{
	if (m_nSelStartLine == m_nSelEndLine && m_nSelStartCol == m_nSelEndCol)
		return;

	HGLOBAL hGlobalBin = NULL;
	BOOL bSuccessBin = FALSE;

	// "BinaryData" VC++̃oCiGfB^̃Rs[tH[}bg DWORD̒̂ɃoCif[^
	ULONGLONG nAddressStart = AddressFromLineCol(m_nSelStartLine, m_nSelStartCol, FALSE);
	ULONGLONG nAddressEnd = AddressFromLineCol(m_nSelEndLine, m_nSelEndCol, TRUE);
	if (nAddressEnd > nAddressStart)
	{
		if (nAddressEnd - nAddressStart <= DWORD_MAX)
		{
			DWORD cb = (DWORD)(nAddressEnd - nAddressStart);
			hGlobalBin = GlobalAlloc(GHND | GMEM_DDESHARE, cb + sizeof(DWORD));
			if (hGlobalBin)
			{
				CGlobalPtr<BYTE*> pGlobalBin(hGlobalBin);
				if (pGlobalBin)
				{
					*(DWORD*)(BYTE*)pGlobalBin = cb;
					(*m_pfnCallback)(nAddressStart, cb, pGlobalBin + sizeof(DWORD), m_dwCallbackData1, m_dwCallbackData2);
					bSuccessBin = TRUE;
				}
			}
		}
	}
	else 
	{
		// Rs[f[^͂ȂB͂ł悢B
		bSuccessBin = TRUE;
	}


	HGLOBAL hGlobalText = NULL;
	BOOL bSuccessText = FALSE;

	{
		ULONGLONG cch = 0;
		if (m_nSelStartLine == m_nSelEndLine)
		{
			// sI
			ASSERT(m_nSelEndCol <= GetLineLength(m_nSelStartLine));
			cch += m_nSelEndCol - m_nSelStartCol;
		}
		else
		{
			// ŏ̍s
			ASSERT(m_nSelStartCol <= GetLineLength(m_nSelStartLine));
			cch += GetLineLength(m_nSelStartLine) - m_nSelStartCol + 2;
			// r̍s
			for (LONGLONG nLine = m_nSelStartLine + 1; nLine < m_nSelEndLine; nLine++)
				cch += GetLineLength(nLine) + 2;
			// Ō̍s
			ASSERT(m_nSelEndCol <= GetLineLength(m_nSelEndLine));
			cch += m_nSelEndCol;
		}

		cch++;		// I[nul
	
		if (cch * sizeof(WCHAR) <= SIZE_T_MAX)
		{
			size_t cb = (size_t)cch * sizeof(WCHAR);
			hGlobalText = GlobalAlloc(GHND | GMEM_DDESHARE, cb);
			if (hGlobalText)
			{
				CGlobalPtr<WCHAR*> pGlobal(hGlobalText);
				if (pGlobal)
				{
					WCHAR* pchDst = pGlobal;

					if (m_nSelStartLine == m_nSelEndLine)
					{
						// sI
						CString strLine = GetLineText(m_nSelStartLine);
						const WCHAR* pchLine = (const WCHAR*)strLine;
						int cchLine = m_nSelEndCol - m_nSelStartCol;
						memcpy(pchDst, pchLine + m_nSelStartCol, cchLine * sizeof(WCHAR));
						pchDst += cchLine;
					}
					else
					{
						// ŏ̍s
						CString strLine = GetLineText(m_nSelStartLine);
						const WCHAR* pchLine = (const WCHAR*)strLine;
						int cchLine = GetLineLength(m_nSelStartLine) - m_nSelStartCol;
						if (cchLine)
							memcpy(pchDst, pchLine + m_nSelStartCol, cchLine * sizeof(WCHAR));
						pchDst += cchLine;
						OUT_CRLF();

						// r̍s
						ASSERT(cchLine);
						for (LONGLONG nLine = m_nSelStartLine + 1; nLine < m_nSelEndLine; nLine++)
						{
							cchLine = GetLineLength(nLine);
							GetLineText(pchDst, nLine);
							pchDst += cchLine;
							OUT_CRLF();
						}
						// Ō̍s
						strLine = GetLineText(m_nSelEndLine);
						pchLine = (const WCHAR*)strLine;
						cchLine = m_nSelEndCol;
						if (cchLine)
							memcpy(pchDst, pchLine, cchLine * sizeof(WCHAR));
						pchDst += cchLine;
					}
					*(pchDst++) = NULL;
					ASSERT(cch == (pchDst - pGlobal));
					bSuccessText = TRUE;
				}
			}
		}
	}

	if (OpenClipboard())
	{
		EmptyClipboard();
		if (bSuccessBin && hGlobalBin)
		{
			if (SetClipboardData(RegisterClipboardFormat(L"BinaryData"), hGlobalBin))
				hGlobalBin = NULL;	// ̎qł͂Ȃ
		}
		if (bSuccessText && hGlobalText)
		{
			if (SetClipboardData(CF_UNICODETEXT, hGlobalText))
				hGlobalText = NULL;	// ̎qł͂Ȃ
		}
		CloseClipboard();
	}
	else
	{
		AfxMessageBox(L"Nbv{[hɃRs[ł܂B");
	}

	if (!bSuccessBin || !bSuccessText)
	{
		AfxMessageBox(L"słB");
	}

	// ZbgȂf[^cĂΉ
	if (hGlobalBin)
		GlobalFree(hGlobalBin);

	if (hGlobalText)
		GlobalFree(hGlobalText);



}


void CHexViewCtrl::OnUpdateEditCopy(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_nSelStartLine != m_nSelEndLine || m_nSelStartCol != m_nSelEndCol);
}


void CHexViewCtrl::OnEditSelectAll()
{
	SetCurPos(0, 0, FALSE);
	SetCurPos(m_cLines, 0, TRUE);
}


void CHexViewCtrl::OnUpdateEditSelectAll(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(m_cLines ? TRUE : FALSE);
}

void CHexViewCtrl::OnContextMenu(CWnd* pWnd, CPoint pt)
{
	CMenu menu;
	menu.LoadMenu(IDR_HEXVIEWCTRL_CONTEXT_MENU);
	CMenu* pPopupMenu = menu.GetSubMenu(0);

	BOOL bSel = m_nSelStartLine != m_nSelEndLine || m_nSelStartCol != m_nSelEndCol;
	pPopupMenu->EnableMenuItem(ID_EDIT_COPY, bSel ? MF_ENABLED : MF_GRAYED);

	ULONGLONG nAddressStart = AddressFromLineCol(m_nSelStartLine, m_nSelStartCol, FALSE);
	ULONGLONG nAddressEnd = AddressFromLineCol(m_nSelEndLine, m_nSelEndCol, TRUE);
	BOOL bSelBin = nAddressEnd > nAddressStart;
	pPopupMenu->EnableMenuItem(ID_EDIT_EXPORT, bSelBin ? MF_ENABLED : MF_GRAYED);

	pPopupMenu->EnableMenuItem(ID_EDIT_SELECT_ALL, m_cLines ? MF_ENABLED : MF_GRAYED);

	pPopupMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, pt.x, pt.y, this);	
}



BOOL CHexViewCtrl::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == L'A')
		{
			if (GetKeyState(VK_CONTROL) < 0)
			{
				OnEditSelectAll();
				return TRUE;
			}
		}
		else if (pMsg->wParam == L'C')
		{
			if (GetKeyState(VK_CONTROL) < 0)
			{
				OnEditCopy();
				return TRUE;
			}
		}
		else if (pMsg->wParam == VK_INSERT)
		{
			if (GetKeyState(VK_CONTROL) < 0)
			{
				OnEditCopy();
				return TRUE;
			}
		}
	}

	return CWnd::PreTranslateMessage(pMsg);
}


void CHexViewCtrl::OnEditExport()
{
	ULONGLONG nAddressStart = AddressFromLineCol(m_nSelStartLine, m_nSelStartCol, FALSE);
	ULONGLONG nAddressEnd = AddressFromLineCol(m_nSelEndLine, m_nSelEndCol, TRUE);

	if (nAddressEnd > nAddressStart)
	{
		CFileDialog dlg(FALSE);
		CFileDialog_LongPathAdapter da(dlg);

		if (dlg.DoModal() == IDOK)
		{
			CString strPathName = dlg.GetPathName();

			NFile file;
			if (file.CreateNewFileToWrite(strPathName))
			{
				static const UINT cbBuf = 1024 * 1024;
				vector<BYTE> buf(cbBuf);
				ULONGLONG cbRemain = nAddressEnd - nAddressStart;
				ULONGLONG nPosIn = nAddressStart;

				while (cbRemain)
				{
					UINT cbToRead = (UINT)min(cbBuf, cbRemain);
					(*m_pfnCallback)(nPosIn, cbToRead, buf.data(), m_dwCallbackData1, m_dwCallbackData2);
					file.Write(buf.data(), cbToRead);

					cbRemain -= cbToRead;
					nPosIn += cbToRead;
				}
				file.Close();
			}
			else
			{
				AfxMessageBox(L"t@Cɏ߂܂");
			}
		}
	}
}


void CHexViewCtrl::OnUpdateEditExport(CCmdUI *pCmdUI)
{
	ULONGLONG nAddressStart = AddressFromLineCol(m_nSelStartLine, m_nSelStartCol, FALSE);
	ULONGLONG nAddressEnd = AddressFromLineCol(m_nSelEndLine, m_nSelEndCol, TRUE);
	BOOL bSelBin = nAddressEnd > nAddressStart;
	pCmdUI->Enable(bSelBin);
}
