// ImageViewDialog.cpp : t@C
//

#include "stdafx.h"
#include "ClipMM.h"
#include "ImageViewDialog.h"
#include "afxdialogex.h"
#include "GlobalPtr.h"
#include "Util.h"

#define IDC_IMGWND 100



// CImageViewDialog _CAO

IMPLEMENT_DYNAMIC(CImageViewDialog, CClipMMPropertyPage)

CImageViewDialog::CImageViewDialog(CCBData* pData)
	: CClipMMPropertyPage(pData, CImageViewDialog::IDD)
	, m_pImage(NULL)
{

}

CImageViewDialog::~CImageViewDialog()
{
}

void CImageViewDialog::DoDataExchange(CDataExchange* pDX)
{
	CClipMMPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_IMAGE, m_place);
	DDX_Control(pDX, IDC_STATIC_PROPERTY, m_staticProperty);
}


BEGIN_MESSAGE_MAP(CImageViewDialog, CClipMMPropertyPage)
	ON_WM_SIZE()
	ON_MESSAGE(APM_IMAGESCALECHANGED, &CImageViewDialog::OnApmImagescalechanged)
END_MESSAGE_MAP()


// CImageViewDialog bZ[W nh[


void CImageViewDialog::OnSize(UINT nType, int cx, int cy)
{
	CClipMMPropertyPage::OnSize(nType, cx, cy);

	if (m_imgwnd.m_hWnd)
	{
		CRect rc;
		m_imgwnd.GetWindowRect(rc);
		ScreenToClient(rc);
		rc.right = cx;
		rc.bottom = cy;

		m_imgwnd.MoveWindow(rc);
	}
}


BOOL CImageViewDialog::OnInitDialog()
{
	CClipMMPropertyPage::OnInitDialog();

//	EnableThemeDialogTexture(m_hWnd, ETDT_DISABLE);

	int cx = 0;
	int cy = 0;
	int nBitsPerPixel = 0;

	if (m_pData)
	{
		m_pImage = m_pData->GetImage(cx, cy, nBitsPerPixel);
	}

	if (cx > 0 && cy > 0)
	{
		m_strProperty = UnsignedDecimalString(cx) + L"~" + UnsignedDecimalString(cy);
		if (nBitsPerPixel)
		{
			m_strProperty += L"  ";
			m_strProperty += UnsignedDecimalString(nBitsPerPixel) + L"rbg/sNZ";
		}
	}
	m_staticProperty.SetWindowText(m_strProperty);


	CRect rc;
	m_place.GetWindowRect(rc);
	ScreenToClient(rc);

	m_imgwnd.Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | WS_GROUP, this, IDC_IMGWND);
	m_imgwnd.MoveWindow(rc);
	m_imgwnd.SetImage(m_pImage);
	m_place.ShowWindow(FALSE);


	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CImageViewDialog::OnToolSetDefaultView()
{
	if (m_pData)
		m_pData->SetSuitableType(CCBData::suitabletypeImage);
}




afx_msg LRESULT CImageViewDialog::OnApmImagescalechanged(WPARAM wParam, LPARAM lParam)
{
	CString strProperty = m_strProperty + L" " + (const WCHAR*)lParam;
	m_staticProperty.SetWindowText(strProperty);

	return 0;
}
