// ImgWnd.cpp : t@C
//

#include "stdafx.h"
#include "ClipMM.h"
#include "ImgWnd.h"

#define intceil(a) (int)ceil(a)
#define intround(a) (int)round(a)


// CImgWnd

IMPLEMENT_DYNAMIC(CImgWnd, CWnd)

CImgWnd::CImgWnd()
	: m_pImage(NULL)
	, m_cxImage(0)
	, m_cyImage(0)
{

}

CImgWnd::~CImgWnd()
{
}

BOOL CImgWnd::Create(DWORD dwStyle0, CWnd* pWndParent, UINT nID)
{
	DWORD dwStyle = dwStyle0;

	BOOL b = 
	CWnd::Create(AfxRegisterWndClass(CS_DBLCLKS, AfxGetApp()->LoadStandardCursor(IDC_ARROW)), 
		L"", 
		dwStyle,
		CRect(0, 0, 0, 0),
		pWndParent,
		nID,
		NULL);

	return b;
}

void CImgWnd::SetImage(shared_ptr<Image> pImage)
{
	m_pImage = pImage;
	if (pImage) {
		m_cxImage = pImage->GetWidth();
		m_cyImage = pImage->GetHeight();
	}
	else {
		m_cxImage = 0;
		m_cyImage = 0;
	}

	if (m_hWnd)
	{
		Invalidate();
	}
}

BEGIN_MESSAGE_MAP(CImgWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CImgWnd bZ[W nh[




int CImgWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_cxMargin = m_cyMargin = 5;

	return 0;
}

void CImgWnd::OnDestroy()
{
	CWnd::OnDestroy();
}


void CImgWnd::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	m_cxClient = cx;
	m_cyClient = cy;

	Invalidate();
}


void CImgWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	CRect rcClip;
	dc.GetClipBox(rcClip);

	Graphics g(dc.GetSafeHdc());
	g.Clear(Color(238, 242, 250));

	CString strScale;

	if (m_pImage) {
		int cxImageArea = m_cxClient - m_cxMargin * 2;
		int cyImageArea = m_cyClient - m_cyMargin * 2;
		if (cxImageArea > 0 && cyImageArea > 0) {
			// 摜̔{߂
			REAL xRatio = (REAL)cxImageArea / (REAL)m_cxImage;
			REAL yRatio = (REAL)cyImageArea / (REAL)m_cyImage;

			REAL fRatio = min(xRatio, yRatio);
			if (fRatio > 1.0f) {
				fRatio = 1.0f;
			}

			// 摜`
			// fXeBl[Ṽ͍sNZ̍B-0.5, -0.5
			RectF rcfDest(
				(REAL)m_cxMargin - 0.5f,
				(REAL)m_cyMargin  - 0.5f,
				(REAL)m_cxImage * fRatio,
				(REAL)m_cyImage * fRatio);

			// \[X͍̃sNZ̍B-0.5, -0.5
			RectF rcfSrc(-0.5f, -0.5f, (REAL)m_cxImage, (REAL)m_cyImage);

			g.DrawImage(m_pImage.get(), rcfDest, rcfSrc.X, rcfSrc.Y, rcfSrc.Width, rcfSrc.Height, UnitPixel);

			strScale.Format(L"%.2f %%", fRatio * 100.0f);
		}
	}
	GetParent()->SendMessage(APM_IMAGESCALECHANGED, 0, (LPARAM)(const WCHAR*)strScale);
}

