#pragma once


// CImgWnd

class CImgWnd : public CWnd
{
	DECLARE_DYNAMIC(CImgWnd)

public:
	shared_ptr<Image> m_pImage;
	int m_cxMargin;
	int m_cyMargin;
	int m_cxImage;	
	int m_cyImage;
	int m_cxClient;
	int m_cyClient;

	// obNv[
	class CBackPlane {
	public:
		CBitmap m_bm;
		CDC m_dc;
		CBitmap* m_pbmOld;
		CSize m_sz;
	public:
		CBackPlane() : m_pbmOld(nullptr), m_sz(0, 0) {}
		~CBackPlane() { Destroy(); }

		bool Create(CWnd* pWnd, int cx, int cy) {
			CClientDC dcClient(pWnd);
			m_dc.CreateCompatibleDC(&dcClient);
			m_bm.CreateCompatibleBitmap(&dcClient, cx, cy);
			m_pbmOld = m_dc.SelectObject(&m_bm);
			m_sz.cx = cx;
			m_sz.cy = cy;
			return true;
		}
		void Destroy() {
			m_dc.SelectObject(m_pbmOld);
		}
		bool IsBigEnough(int cx, int cy) {
			if (m_sz.cx >= cx && m_sz.cy >= cy) {
				return true;
			}
			return false;
		}
	};

public:
	CImgWnd();
	virtual ~CImgWnd();

	BOOL Create(DWORD dwStyle, CWnd* pWndParent, UINT nID);
	void SetImage(shared_ptr<Image> pImage);

protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
};


