#include "stdafx.h"
#include "NewSelectFolder.h"

BOOL NewSelectFolder(HWND hwndParent, const CString& strFolderDefault, CString& strFolder)
{
	CComPtr<IFileDialog> pDialog;
	HRESULT hr = CoCreateInstance(CLSID_FileOpenDialog, NULL, CLSCTX_INPROC_SERVER, IID_PPV_ARGS(&pDialog));
	if (SUCCEEDED(hr)) 
	{
		FILEOPENDIALOGOPTIONS options;
		pDialog->GetOptions(&options);
		pDialog->SetOptions(options | FOS_FORCEFILESYSTEM | FOS_PICKFOLDERS);

		vector<WCHAR> szFolderDefault;
		szFolderDefault.resize(strFolderDefault.GetLength() + 1);
		wcscpy(szFolderDefault.data(), (const WCHAR*)strFolderDefault);
		CComPtr<IShellItem> pItemFolder;
		hr = ::SHCreateItemFromParsingName(szFolderDefault.data(), NULL, IID_PPV_ARGS(&pItemFolder));
		if (SUCCEEDED(hr)) 
		{
			pDialog->SetDefaultFolder(pItemFolder);
		}

		hr = pDialog->Show(hwndParent);

		if (SUCCEEDED(hr)) 
		{
			CComPtr<IShellItem> pItem;
			hr = pDialog->GetResult(&pItem);
			if (SUCCEEDED(hr)) 
			{
				CComHeapPtr<WCHAR> pszPath;
				hr = pItem->GetDisplayName(SIGDN_FILESYSPATH, &pszPath);
				if (SUCCEEDED(hr)) 
				{
					strFolder = pszPath;
					return TRUE;
				}
			}
		}
	}
	return FALSE;
}

