#include "stdafx.h"
#include "util.h"

CString StringFromStringArray(const CStringArray& arrayStr, const WCHAR* pszSeparator)
{
	if (pszSeparator == NULL)
		pszSeparator = L"\r\n";

	CString str;
	for (int i = 0; i < arrayStr.GetSize(); i++)
	{
		str += arrayStr[i] + pszSeparator;
	}
	return str;
}

CString StringFromStringArray(const WCHAR* arrayStr[], size_t nCount, const WCHAR* pszSeparator)
{
	if (pszSeparator == NULL)
		pszSeparator = L"\r\n";

	CString str;
	for (size_t i = 0; i < nCount; i++)
	{
		str += arrayStr[i];
		str += pszSeparator;
	}
	return str;
}

void StringArrayFromString(CStringArray& arrayStr, const WCHAR *pszStr, const WCHAR* pszSeparator)
{
	if (pszSeparator == NULL)
		pszSeparator = L"\r\n";
	int cchSeparator = (int)wcslen(pszSeparator);

	arrayStr.RemoveAll();
	const WCHAR* pch = pszStr;

	while (TRUE)
	{
		const WCHAR* pchFound = wcsstr(pch, pszSeparator);
		if (pchFound)
		{
			arrayStr.Add(CString(pch, (int)(pchFound - pch)));
			pch = pchFound + cchSeparator;
		}
		else
		{
			break;
		}
	}
	if (*pch)
	{
		arrayStr.Add(pch);
	}
}

CString UnsignedDecimalString(unsigned int n)
{
	CString str;
	str.Format(L"%u", n);
	return str;
}


CString UnsignedLongLongDecimalString(unsigned __int64 n)
{
	CString str;
	str.Format(L"%llu", n);
	return str;
}

CString SizeDecimalString(size_t n)
{
#ifdef _M_X64
	ASSERT(sizeof(size_t) == sizeof(__int64));
	CString str;
	str.Format(L"%llu", n);
	return str;

#else
	ASSERT(sizeof(size_t) == sizeof(int));
	CString str;
	str.Format(L"%u", n);
	return str;
#endif
}

CString DoubleAmp(const CString& str)
{
	CString strResult;
	for (int i = 0; i < str.GetLength(); i++)
	{
		if (str[i] == L'&')
			strResult += L"&&";
		else
			strResult += str[i];

	}
	return strResult;
}

CString MakePathName(const CString& strDir, const CString& strFile)
{
	if (strDir.Right(1) == L"\\")
		return strDir + strFile;
	else
		return strDir + L"\\" + strFile;
}

UINT DragQueryFileCount(HDROP hdrop)
{
	return DragQueryFile(hdrop, (UINT)-1, NULL, 0);
}

UINT DragQueryFile(HDROP hdrop, UINT iFile, CString& strFile)
{
	UINT cch = DragQueryFile(hdrop, iFile, NULL, 0);
	if (!cch) {
		strFile.Empty();
		return cch;
	}
	// APIcch͏I[NUL̕܂܂ȂB
	cch++;
	vector<WCHAR> buf(cch);
	cch = DragQueryFile(hdrop, iFile, buf.data(), cch);
	strFile = buf.data();
	return cch;
}

DWORD GetTempPath(CString& strPath)
{
	DWORD dw = GetTempPath(0, NULL);
	if (dw == 0) {
		strPath.Empty();
		return 0;
	}

	DWORD cch = dw;
	vector<WCHAR> buf(cch);
	dw = GetTempPath(cch, buf.data());
	strPath = buf.data();
	return dw;
}


void RotateExif(Image* pBitmap, int nOrientation)
{
	//PropertyTagOrientation 
	if (pBitmap && pBitmap->GetWidth() && pBitmap->GetHeight()) {
		/*
		sƗ̊ϓ_猩A摜̕B
		Tag    =  274 (112.H)
		Type   =  SHORT
		Count  =  1
		Default
		=  1
		1     =  0 Ԗڂ̍sڂŌƂ̉摜̏(visual top)A0 Ԗڂ̗񂪍(visual left-hand side)ƂȂB
		2     =  0 Ԗڂ̍sڂŌƂ̉摜̏A0 Ԗڂ̗񂪉E(visual right-hand side)ƂȂB
		3     =  0 Ԗڂ̍sڂŌƂ̉摜̉(visual bottom)A0 Ԗڂ̗񂪉EƂȂB
		4     =  0 Ԗڂ̍sڂŌƂ̉摜̉A0 Ԗڂ̗񂪍ƂȂB
		5     =  0 Ԗڂ̍sڂŌƂ̉摜̍A0 Ԗڂ̗񂪏ƂȂB
		6     =  0 Ԗڂ̍sڂŌƂ̉摜̉EA0 Ԗڂ̗񂪏ƂȂB
		7     =  0 Ԗڂ̍sڂŌƂ̉摜̉EA0 Ԗڂ̗񂪉ƂȂB
		8     =  0 Ԗڂ̍sڂŌƂ̉摜̍A0 Ԗڂ̗񂪉ƂȂB
		̑    =  \
		*/
		RotateFlipType type = RotateNoneFlipNone;
		switch (nOrientation) {
		case 1:
			//   
			// @E
			//   
			// ̂܂
			break;
		case 2:
			//   
			// E@
			//   
			// E]
			type = RotateNoneFlipX;
			break;
		case 3:
			//   
			// E@
			//   
			// ㉺E]
			type = RotateNoneFlipXY;
			break;
		case 4:
			//   
			// @E
			//   
			// ㉺]
			type = RotateNoneFlipY;
			break;
		case 5:
			//   
			// @
			//   E
			// 90x]㍶E]
			type = Rotate90FlipX;
			break;
		case 6:
			//   E
			// @
			// @
			// 90x]
			type = Rotate90FlipNone;
			break;
		case 7:
			//   E
			// @
			//   
			// 270x]㍶E]
			type = Rotate270FlipX;
			break;
		case 8:
			//   
			// @
			//   E
			// 270x]
			type = Rotate270FlipNone;
			break;
		}
		if (type != RotateNoneFlipNone)
			pBitmap->RotateFlip(type);
	}
}

int CompareNoCaseX(const CString& str1, const CString& str2)
{

	NLSVERSIONINFOEX nvi = { 0 };
	nvi.dwNLSVersionInfoSize = sizeof(nvi);
	GetNLSVersionEx(COMPARE_STRING, LOCALE_NAME_SYSTEM_DEFAULT, &nvi);


	int n = CompareStringEx(LOCALE_NAME_SYSTEM_DEFAULT,
		/*LINGUISTIC_IGNORECASE |*/ NORM_LINGUISTIC_CASING | NORM_IGNORECASE | SORT_DIGITSASNUMBERS,
		str1,
		str1.GetLength(),
		str2,
		str2.GetLength(),
		(NLSVERSIONINFO*)&nvi,
		NULL,
		0);

	if (n == CSTR_LESS_THAN || n == CSTR_GREATER_THAN) {
		// ňႢoȂ炱̏̂قڎR
	}
	else {
		n = CompareStringOrdinal(str1, str1.GetLength(), str2, str2.GetLength(), TRUE);
	}

	return n - CSTR_EQUAL;
}



