#pragma once

extern CString StringFromStringArray(const CStringArray& arrayStr, const WCHAR* pszSeparator);
extern CString StringFromStringArray(const WCHAR* arrayStr[], size_t nCount, const WCHAR* pszSeparator);
void StringArrayFromString(CStringArray& arrayStr, const WCHAR *pszStr, const WCHAR* pszSeparator);

extern CString UnsignedDecimalString(unsigned int n);
extern CString UnsignedLongLongDecimalString(unsigned __int64 n);
extern CString SizeDecimalString(size_t n);
extern CString DoubleAmp(const CString& str);

extern CString MakePathName(const CString& strDir, const CString& strFile);

extern UINT DragQueryFileCount(HDROP hdrop);
extern UINT DragQueryFile(HDROP hdrop, UINT iFile, CString& strFile);
extern DWORD GetTempPath(CString& strPath);

// IɒȂAPIł͂Ƃ肠ߑł
#define LONG_PATH_UTIL_MAX 65536	// not including terminating NUL

class CFileDialog_LongPathAdapter
{
protected:
	CFileDialog& m_dlg;
	vector<WCHAR> m_buf;

public:
	CFileDialog_LongPathAdapter(CFileDialog& dlg, const WCHAR* pszFileName = NULL)
		: m_dlg(dlg)
	{
		m_buf.resize(LONG_PATH_UTIL_MAX + 1);
		dlg.m_ofn.lpstrFile = m_buf.data();
		dlg.m_ofn.nMaxFile = LONG_PATH_UTIL_MAX + 1;

		if (pszFileName) 
		{
			auto cchIn = wcslen(pszFileName);
			if (cchIn) {
				if (cchIn > LONG_PATH_UTIL_MAX) 
				{
					cchIn = LONG_PATH_UTIL_MAX;
				}
				memcpy(dlg.m_ofn.lpstrFile, pszFileName, cchIn * sizeof(WCHAR));
			}
			dlg.m_ofn.lpstrFile[cchIn] = 0;
		}
	}
};


extern void RotateExif(Image* pBitmap, int nOrientation);

extern int CompareNoCaseX(const CString& str1, const CString& str2);


class CompareXString : public CString
{
public:
	//	wstring m_str;
	CompareXString(const WCHAR* psz) : CString(psz) {}
	//	operator wstring() const { return m_str; }

	bool operator < (const CompareXString& other) const
	{
		return CompareNoCaseX(*this, other) < 0;
	}
	bool operator <= (const CompareXString& other) const
	{
		return CompareNoCaseX(*this, other) <= 0;
	}
	bool operator > (const CompareXString& other) const
	{
		return CompareNoCaseX(*this, other) > 0;
	}
	bool operator >= (const CompareXString& other) const
	{
		return CompareNoCaseX(*this, other) >= 0;
	}
	bool operator == (const CompareXString& other) const
	{
		return CompareNoCaseX(*this, other) == 0;
	}
	bool operator != (const CompareXString& other) const
	{
		return CompareNoCaseX(*this, other) != 0;
	}
};

